"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
var DialogFlowModule_1;
require("reflect-metadata");
const constant_1 = require("../constant");
const dialog_flow_authorization_middleware_1 = require("../middlewares/dialog-flow-authorization.middleware");
const dialog_flow_controller_1 = require("./dialog-flow.controller");
const dialog_flow_provider_1 = require("./dialog-flow.provider");
const discovery_1 = require("@nestjs-plus/discovery");
const common_1 = require("@nestjs/common");
const core_1 = require("../core");
let DialogFlowModule = DialogFlowModule_1 = class DialogFlowModule {
    constructor(discoveryService, handlerContainer) {
        this.discoveryService = discoveryService;
        this.handlerContainer = handlerContainer;
    }
    static forRoot(webHookConfig) {
        webHookConfig = Object.assign({ basePath: 'web-hooks', postPath: 'dialog-flow' }, webHookConfig);
        return {
            module: DialogFlowModule_1,
            providers: [dialog_flow_provider_1.DialogFlowProvider, core_1.HandlerContainer],
            controllers: [dialog_flow_controller_1.DialogFlowController.forRoot(webHookConfig)],
        };
    }
    onModuleInit() {
        return __awaiter(this, void 0, void 0, function* () {
            const providersMethodAndMetaForIntent = yield this.discoveryService.providerMethodsWithMetaAtKey(constant_1.DIALOG_FLOW_INTENT);
            const providersMethodAndMetaForAction = yield this.discoveryService.providerMethodsWithMetaAtKey(constant_1.DIALOG_FLOW_ACTION);
            const providersMethodAndMeta = [
                ...providersMethodAndMetaForIntent,
                ...providersMethodAndMetaForAction,
            ];
            for (const providerMethodAndMeta of providersMethodAndMeta) {
                this.handlerContainer.register(providerMethodAndMeta.meta, providerMethodAndMeta.discoveredMethod.parentClass.instance, providerMethodAndMeta.discoveredMethod.methodName);
            }
        });
    }
    configure(consumer) {
        return consumer.apply(dialog_flow_authorization_middleware_1.DialogFlowAuthorizationMiddleware).forRoutes(dialog_flow_controller_1.DialogFlowController);
    }
};
DialogFlowModule = DialogFlowModule_1 = __decorate([
    common_1.Module({
        imports: [discovery_1.DiscoveryModule],
        providers: [dialog_flow_provider_1.DialogFlowProvider, core_1.HandlerContainer],
        controllers: [dialog_flow_controller_1.DialogFlowController],
    }),
    __metadata("design:paramtypes", [discovery_1.DiscoveryService,
        core_1.HandlerContainer])
], DialogFlowModule);
exports.DialogFlowModule = DialogFlowModule;
